package ukol;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.sql.SQLException;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 * Hlavní třída aplikace zobrazující výsledky dotazů do databáze knih.
 */
public class QueryApp {

    /**
     * Plně kvalifikované jméno JDBC ovladače použitého pro komunikaci s databází.
     */
    public static final String JDBC_DRIVER = "com.mysql.jdbc.Driver";
    /**
     * Adresa databáze, zahrnuje adresu serveru a název databáze.
     */
    public static final String DATABASE_URL = "jdbc:mysql://localhost/books";
    /**
     * Uživatelské jméno použité při připojení k databázi.
     */
    public static final String USERNAME = "jhtp6";
    /**
     * Heslo použité při připojení k databázi.
     */
    public static final String PASSWORD = "jhtp6";

    public static void main(String[] args) {
        try {
            final ResultSetTableModel tableModel =
                    new ResultSetTableModel(JDBC_DRIVER, DATABASE_URL, USERNAME, PASSWORD);

            JFrame frame = new JFrame("Dotazy do databáze knih");
            frame.add(new DisplayQueryResults(tableModel));
            frame.setSize(700, 250);
            frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
            frame.addWindowListener(new WindowAdapter() {

                public void windowClosing(WindowEvent event) {
                    // při zavření okna dojde k odpojení od databáze
                    // a ukončení aplikace
                    tableModel.disconnectFromDatabase();
                    System.exit(0);
                }
            });
            frame.setVisible(true);
        } catch (SQLException e) {
            JOptionPane.showMessageDialog(null, "Chyba připojení k databázi:\n"
                    + e.toString(), "Chyba", JOptionPane.ERROR_MESSAGE);
        } catch (ClassNotFoundException e) {
            JOptionPane.showMessageDialog(null,
                    "Nepodařilo se načíst JDBC ovladač.", "Chyba",
                    JOptionPane.ERROR_MESSAGE);
        }
    }
}
